---
title: Nest Content Within Choice Options
product: Form Library
description: Build conditional, cascading follow-up questions within the choice options of the Checkboxes and Radio Button Group questions. A sub-question dynamically appears when a nested choice option gets selected. View our free JavaScript demo to learn more.
framework: Vanilla JS
source: https://surveyjs.io/form-library/examples/nest-follow-up-questions-within-choice-options/vanillajs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Nest Content Within Choice Options (Vanilla JS)

You can nest follow-up questions or panels inside individual options of the Checkboxes and Radio Button Group questions. This layout is useful when certain answer choices require additional input from the respondent. For example, selecting "Music events" can display a follow-up question asking which genres or venues the respondent prefers. This demo illustrates how to implement such a nested layout.

Each choice item in Checkboxes and Radio Button Group questions supports an `elements` array. You can define questions and panels within this array, and they will appear dynamically when the user selects the corresponding choice.

Nesting is not limited to a single level. Nested Checkboxes or Radio Button Group questions can, in turn, contain their own nested elements. Refer to the survey JSON schema in the Code tab for an implementation example.

## See Also

[View Content Nesting Demo in Survey Creator](/survey-creator/examples/nest-sub-questions-within-choice-options/ (linkStyle))

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import { Model } from "survey-core";
import "survey-js-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

const survey = new Model(json);
survey.onComplete.add((sender, options) => {
    console.log(JSON.stringify(sender.data, null, 3));
});
survey.data = {
    "event_preferences": [
        "music"
    ],
    "music_event_type": [
        "festival"
    ],
    "preferred_festival_name": "Battle of the bands",
    "contact_methods": [
        "telegram"
    ],
    "telegram_username": "@example"
}

survey.render(document.getElementById("surveyElement"));
```

### `src/json.js`

```js
export const json = {
  "elements": [
    {
      "type": "checkbox",
      "name": "event_preferences",
      "title": "Which types of events are you interested in attending?",
      "choices": [
        {
          "value": "music",
          "text": "Music events",
          "elements": [
            {
              "type": "checkbox",
              "name": "music_event_type",
              "title": "Which type of music event would you like to attend?",
              "isRequired": true,
              "choices": [
                {
                  "value": "concert",
                  "text": "Concert",
                  "elements": [
                    {
                      "type": "text",
                      "name": "preferred_concert_genre",
                      "titleLocation": "hidden",
                      "isRequired": true,
                      "placeholder": "Enter preferred music genre (e.g., Rock, Jazz)"
                    },
                    {
                      "type": "text",
                      "name": "preferred_concert_date",
                      "titleLocation": "hidden",
                      "inputType": "month",
                      "placeholder": "Preferred date"
                    }
                  ]
                },
                {
                  "value": "festival",
                  "text": "Music festival",
                  "elements": [
                    {
                      "type": "text",
                      "name": "preferred_festival_name",
                      "titleLocation": "hidden",
                      "isRequired": true,
                      "placeholder": "Enter festival name or type"
                    }
                  ]
                }
              ]
            }
          ]
        },
        {
          "value": "sports",
          "text": "Sports events",
          "elements": [
            {
              "type": "checkbox",
              "name": "sports_event_type",
              "title": "Which sports events are you interested in?",
              "isRequired": true,
              "choices": [
                {
                  "value": "match",
                  "text": "Live match",
                  "elements": [
                    {
                      "type": "dropdown",
                      "name": "preferred_sport",
                      "titleLocation": "hidden",
                      "isRequired": true,
                      "choices": [
                        "Football",
                        "Basketball",
                        "Tennis"
                      ],
                      "placeholder": "Select sport"
                    }
                  ]
                },
                {
                  "value": "tournament",
                  "text": "Tournament",
                  "elements": [
                    {
                      "type": "text",
                      "name": "preferred_tournament",
                      "titleLocation": "hidden",
                      "isRequired": true,
                      "placeholder": "Enter preferred tournament (e.g., Wimbledon)"
                    }
                  ]
                }
              ]
            }
          ]
        },
        {
          "value": "cultural",
          "text": "Cultural events",
          "elements": [
            {
              "type": "checkbox",
              "name": "cultural_event_type",
              "title": "Which cultural event are you interested in?",
              "isRequired": true,
              "choices": [
                {
                  "value": "museum",
                  "text": "Museum exhibition",
                  "elements": [
                    {
                      "type": "text",
                      "name": "preferred_museum_theme",
                      "titleLocation": "hidden",
                      "isRequired": true,
                      "placeholder": "Enter theme or type (e.g., Art, History)"
                    }
                  ]
                },
                {
                  "value": "theater",
                  "text": "Theater performance",
                  "elements": [
                    {
                      "type": "text",
                      "name": "preferred_theater_show",
                      "titleLocation": "hidden",
                      "isRequired": true,
                      "placeholder": "Enter the name of the show"
                    }
                  ]
                }
              ]
            }
          ]
        }
      ]
    },
    {
      "type": "checkbox",
      "name": "contact_methods",
      "title": "How may we contact you?",
      "choices": [
        {
          "value": "email",
          "text": "By email",
          "elements": [
            {
              "type": "text",
              "name": "email_address",
              "titleLocation": "hidden",
              "inputType": "email",
              "placeholder": "Enter your email address"
            }
          ]
        },
        {
          "value": "phone_call",
          "text": "By phone call",
          "elements": [
            {
              "type": "text",
              "name": "phone_number_call",
              "titleLocation": "hidden",
              "isRequired": true,
              "inputType": "tel",
              "placeholder": "Enter your phone number"
            },
            {
              "type": "comment",
              "name": "preferred_call_time",
              "titleLocation": "hidden",
              "placeholder": "Enter a convenient time to call"
            }
          ]
        },
        {
          "value": "sms",
          "text": "By SMS",
          "elements": [
            {
              "type": "text",
              "name": "phone_number_sms",
              "titleLocation": "hidden",
              "valueName": "phone_number_call",
              "inputType": "tel",
              "placeholder": "Enter your phone number"
            }
          ]
        },
        {
          "value": "telegram",
          "text": "By Telegram",
          "elements": [
            {
              "type": "text",
              "name": "telegram_username",
              "titleLocation": "hidden",
              "isRequired": true,
              "placeholder": "Enter your Telegram username"
            }
          ]
        }
      ]
    }
  ]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/nest-follow-up-questions-within-choice-options/angular.md)
- [React](https://surveyjs.io/form-library/examples/nest-follow-up-questions-within-choice-options/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/nest-follow-up-questions-within-choice-options/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/nest-follow-up-questions-within-choice-options/jquery.md)


---
title: Nest Content Within Choice Options
product: Form Library
description: Build conditional, cascading follow-up questions within the choice options of the Checkboxes and Radio Button Group questions. A sub-question dynamically appears when a nested choice option gets selected. View our free JavaScript demo to learn more.
framework: React
source: https://surveyjs.io/form-library/examples/nest-follow-up-questions-within-choice-options/reactjs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Nest Content Within Choice Options (React)

You can nest follow-up questions or panels inside individual options of the Checkboxes and Radio Button Group questions. This layout is useful when certain answer choices require additional input from the respondent. For example, selecting "Music events" can display a follow-up question asking which genres or venues the respondent prefers. This demo illustrates how to implement such a nested layout.

Each choice item in Checkboxes and Radio Button Group questions supports an `elements` array. You can define questions and panels within this array, and they will appear dynamically when the user selects the corresponding choice.

Nesting is not limited to a single level. Nested Checkboxes or Radio Button Group questions can, in turn, contain their own nested elements. Refer to the survey JSON schema in the Code tab for an implementation example.

## See Also

[View Content Nesting Demo in Survey Creator](/survey-creator/examples/nest-sub-questions-within-choice-options/ (linkStyle))

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/SurveyComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function SurveyComponent() {
    const survey = new Model(json);
    survey.onComplete.add((sender, options) => {
        console.log(JSON.stringify(sender.data, null, 3));
    });
    survey.data = {
        "event_preferences": [
            "music"
        ],
        "music_event_type": [
            "festival"
        ],
        "preferred_festival_name": "Battle of the bands",
        "contact_methods": [
            "telegram"
        ],
        "telegram_username": "@example"
    }
    return (<Survey model={survey} />);
}

export default SurveyComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyComponent from "./SurveyComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyComponent />);
```

### `src/json.js`

```js
export const json = {
  "elements": [
    {
      "type": "checkbox",
      "name": "event_preferences",
      "title": "Which types of events are you interested in attending?",
      "choices": [
        {
          "value": "music",
          "text": "Music events",
          "elements": [
            {
              "type": "checkbox",
              "name": "music_event_type",
              "title": "Which type of music event would you like to attend?",
              "isRequired": true,
              "choices": [
                {
                  "value": "concert",
                  "text": "Concert",
                  "elements": [
                    {
                      "type": "text",
                      "name": "preferred_concert_genre",
                      "titleLocation": "hidden",
                      "isRequired": true,
                      "placeholder": "Enter preferred music genre (e.g., Rock, Jazz)"
                    },
                    {
                      "type": "text",
                      "name": "preferred_concert_date",
                      "titleLocation": "hidden",
                      "inputType": "month",
                      "placeholder": "Preferred date"
                    }
                  ]
                },
                {
                  "value": "festival",
                  "text": "Music festival",
                  "elements": [
                    {
                      "type": "text",
                      "name": "preferred_festival_name",
                      "titleLocation": "hidden",
                      "isRequired": true,
                      "placeholder": "Enter festival name or type"
                    }
                  ]
                }
              ]
            }
          ]
        },
        {
          "value": "sports",
          "text": "Sports events",
          "elements": [
            {
              "type": "checkbox",
              "name": "sports_event_type",
              "title": "Which sports events are you interested in?",
              "isRequired": true,
              "choices": [
                {
                  "value": "match",
                  "text": "Live match",
                  "elements": [
                    {
                      "type": "dropdown",
                      "name": "preferred_sport",
                      "titleLocation": "hidden",
                      "isRequired": true,
                      "choices": [
                        "Football",
                        "Basketball",
                        "Tennis"
                      ],
                      "placeholder": "Select sport"
                    }
                  ]
                },
                {
                  "value": "tournament",
                  "text": "Tournament",
                  "elements": [
                    {
                      "type": "text",
                      "name": "preferred_tournament",
                      "titleLocation": "hidden",
                      "isRequired": true,
                      "placeholder": "Enter preferred tournament (e.g., Wimbledon)"
                    }
                  ]
                }
              ]
            }
          ]
        },
        {
          "value": "cultural",
          "text": "Cultural events",
          "elements": [
            {
              "type": "checkbox",
              "name": "cultural_event_type",
              "title": "Which cultural event are you interested in?",
              "isRequired": true,
              "choices": [
                {
                  "value": "museum",
                  "text": "Museum exhibition",
                  "elements": [
                    {
                      "type": "text",
                      "name": "preferred_museum_theme",
                      "titleLocation": "hidden",
                      "isRequired": true,
                      "placeholder": "Enter theme or type (e.g., Art, History)"
                    }
                  ]
                },
                {
                  "value": "theater",
                  "text": "Theater performance",
                  "elements": [
                    {
                      "type": "text",
                      "name": "preferred_theater_show",
                      "titleLocation": "hidden",
                      "isRequired": true,
                      "placeholder": "Enter the name of the show"
                    }
                  ]
                }
              ]
            }
          ]
        }
      ]
    },
    {
      "type": "checkbox",
      "name": "contact_methods",
      "title": "How may we contact you?",
      "choices": [
        {
          "value": "email",
          "text": "By email",
          "elements": [
            {
              "type": "text",
              "name": "email_address",
              "titleLocation": "hidden",
              "inputType": "email",
              "placeholder": "Enter your email address"
            }
          ]
        },
        {
          "value": "phone_call",
          "text": "By phone call",
          "elements": [
            {
              "type": "text",
              "name": "phone_number_call",
              "titleLocation": "hidden",
              "isRequired": true,
              "inputType": "tel",
              "placeholder": "Enter your phone number"
            },
            {
              "type": "comment",
              "name": "preferred_call_time",
              "titleLocation": "hidden",
              "placeholder": "Enter a convenient time to call"
            }
          ]
        },
        {
          "value": "sms",
          "text": "By SMS",
          "elements": [
            {
              "type": "text",
              "name": "phone_number_sms",
              "titleLocation": "hidden",
              "valueName": "phone_number_call",
              "inputType": "tel",
              "placeholder": "Enter your phone number"
            }
          ]
        },
        {
          "value": "telegram",
          "text": "By Telegram",
          "elements": [
            {
              "type": "text",
              "name": "telegram_username",
              "titleLocation": "hidden",
              "isRequired": true,
              "placeholder": "Enter your Telegram username"
            }
          ]
        }
      ]
    }
  ]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/nest-follow-up-questions-within-choice-options/angular.md)
- [Vue 3](https://surveyjs.io/form-library/examples/nest-follow-up-questions-within-choice-options/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/nest-follow-up-questions-within-choice-options/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/nest-follow-up-questions-within-choice-options/vanillajs.md)


---
title: Nest Content Within Choice Options
product: Form Library
description: Build conditional, cascading follow-up questions within the choice options of the Checkboxes and Radio Button Group questions. A sub-question dynamically appears when a nested choice option gets selected. View our free JavaScript demo to learn more.
framework: Angular
source: https://surveyjs.io/form-library/examples/nest-follow-up-questions-within-choice-options/angular
index: https://surveyjs.io/form-library/examples/overview.md
---

# Nest Content Within Choice Options (Angular)

You can nest follow-up questions or panels inside individual options of the Checkboxes and Radio Button Group questions. This layout is useful when certain answer choices require additional input from the respondent. For example, selecting "Music events" can display a follow-up question asking which genres or venues the respondent prefers. This demo illustrates how to implement such a nested layout.

Each choice item in Checkboxes and Radio Button Group questions supports an `elements` array. You can define questions and panels within this array, and they will appear dynamically when the user selects the corresponding choice.

Nesting is not limited to a single level. Nested Checkboxes or Radio Button Group questions can, in turn, contain their own nested elements. Refer to the survey JSON schema in the Code tab for an implementation example.

## See Also

[View Content Nesting Demo in Survey Creator](/survey-creator/examples/nest-sub-questions-within-choice-options/ (linkStyle))

## Files

### `src/app/components/json.ts`

```ts
export const json = {
  "elements": [
    {
      "type": "checkbox",
      "name": "event_preferences",
      "title": "Which types of events are you interested in attending?",
      "choices": [
        {
          "value": "music",
          "text": "Music events",
          "elements": [
            {
              "type": "checkbox",
              "name": "music_event_type",
              "title": "Which type of music event would you like to attend?",
              "isRequired": true,
              "choices": [
                {
                  "value": "concert",
                  "text": "Concert",
                  "elements": [
                    {
                      "type": "text",
                      "name": "preferred_concert_genre",
                      "titleLocation": "hidden",
                      "isRequired": true,
                      "placeholder": "Enter preferred music genre (e.g., Rock, Jazz)"
                    },
                    {
                      "type": "text",
                      "name": "preferred_concert_date",
                      "titleLocation": "hidden",
                      "inputType": "month",
                      "placeholder": "Preferred date"
                    }
                  ]
                },
                {
                  "value": "festival",
                  "text": "Music festival",
                  "elements": [
                    {
                      "type": "text",
                      "name": "preferred_festival_name",
                      "titleLocation": "hidden",
                      "isRequired": true,
                      "placeholder": "Enter festival name or type"
                    }
                  ]
                }
              ]
            }
          ]
        },
        {
          "value": "sports",
          "text": "Sports events",
          "elements": [
            {
              "type": "checkbox",
              "name": "sports_event_type",
              "title": "Which sports events are you interested in?",
              "isRequired": true,
              "choices": [
                {
                  "value": "match",
                  "text": "Live match",
                  "elements": [
                    {
                      "type": "dropdown",
                      "name": "preferred_sport",
                      "titleLocation": "hidden",
                      "isRequired": true,
                      "choices": [
                        "Football",
                        "Basketball",
                        "Tennis"
                      ],
                      "placeholder": "Select sport"
                    }
                  ]
                },
                {
                  "value": "tournament",
                  "text": "Tournament",
                  "elements": [
                    {
                      "type": "text",
                      "name": "preferred_tournament",
                      "titleLocation": "hidden",
                      "isRequired": true,
                      "placeholder": "Enter preferred tournament (e.g., Wimbledon)"
                    }
                  ]
                }
              ]
            }
          ]
        },
        {
          "value": "cultural",
          "text": "Cultural events",
          "elements": [
            {
              "type": "checkbox",
              "name": "cultural_event_type",
              "title": "Which cultural event are you interested in?",
              "isRequired": true,
              "choices": [
                {
                  "value": "museum",
                  "text": "Museum exhibition",
                  "elements": [
                    {
                      "type": "text",
                      "name": "preferred_museum_theme",
                      "titleLocation": "hidden",
                      "isRequired": true,
                      "placeholder": "Enter theme or type (e.g., Art, History)"
                    }
                  ]
                },
                {
                  "value": "theater",
                  "text": "Theater performance",
                  "elements": [
                    {
                      "type": "text",
                      "name": "preferred_theater_show",
                      "titleLocation": "hidden",
                      "isRequired": true,
                      "placeholder": "Enter the name of the show"
                    }
                  ]
                }
              ]
            }
          ]
        }
      ]
    },
    {
      "type": "checkbox",
      "name": "contact_methods",
      "title": "How may we contact you?",
      "choices": [
        {
          "value": "email",
          "text": "By email",
          "elements": [
            {
              "type": "text",
              "name": "email_address",
              "titleLocation": "hidden",
              "inputType": "email",
              "placeholder": "Enter your email address"
            }
          ]
        },
        {
          "value": "phone_call",
          "text": "By phone call",
          "elements": [
            {
              "type": "text",
              "name": "phone_number_call",
              "titleLocation": "hidden",
              "isRequired": true,
              "inputType": "tel",
              "placeholder": "Enter your phone number"
            },
            {
              "type": "comment",
              "name": "preferred_call_time",
              "titleLocation": "hidden",
              "placeholder": "Enter a convenient time to call"
            }
          ]
        },
        {
          "value": "sms",
          "text": "By SMS",
          "elements": [
            {
              "type": "text",
              "name": "phone_number_sms",
              "titleLocation": "hidden",
              "valueName": "phone_number_call",
              "inputType": "tel",
              "placeholder": "Enter your phone number"
            }
          ]
        },
        {
          "value": "telegram",
          "text": "By Telegram",
          "elements": [
            {
              "type": "text",
              "name": "telegram_username",
              "titleLocation": "hidden",
              "isRequired": true,
              "placeholder": "Enter your Telegram username"
            }
          ]
        }
      ]
    }
  ]
};
```

### `src/app/components/survey.component.css`

```css
/* You can add your custom CSS here. */
```

### `src/app/components/survey.component.html`

```html
<survey [model]="model" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; height:100%"></survey>
```

### `src/app/components/survey.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { Model } from "survey-core";
import { json } from "./json";
import "./survey.component.css";
import "survey-core/survey-core.min.css";

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey",
    templateUrl: "./survey.component.html",
    styleUrls: ["./survey.component.css"]
})
export class SurveyComponent implements OnInit {
    model: Model;
    ngOnInit() {
        const survey = new Model(json);
        survey.data = {
            "event_preferences": [
                "music"
            ],
            "music_event_type": [
                "festival"
            ],
            "preferred_festival_name": "Battle of the bands",
            "contact_methods": [
                "telegram"
            ],
            "telegram_username": "@example"
        }
        survey.onComplete.add((sender, options) => {
            console.log(JSON.stringify(sender.data, null, 3));
        });
        this.model = survey;
    }
}
```

### `src/app/components/theme.ts`

```ts
export const themeJson = {};
```

### `src/app/app.component.css`

```css

```

### `src/app/app.component.html`

```html
<component-survey></component-survey>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html",
    styleUrls: ["./app.component.css"]
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";

import { AppComponent } from "./app.component";
import { SurveyModule } from "survey-angular-ui";
import { SurveyComponent } from "./components/survey.component";

@NgModule({
    declarations: [AppComponent, SurveyComponent],
    imports: [BrowserModule, SurveyModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
/* You can add your custom CSS here. */
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css" ],
      "scripts": [ ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-core": "latest",
    "survey-angular-ui": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular/cli": "1.6.6",
    "@angular/compiler-cli": "^5.2.0",
    "@angular/language-service": "^5.2.0",
    "@types/core-js": "0.9.46",
    "@types/jasmine": "~2.8.3",
    "@types/jasminewd2": "~2.0.2",
    "@types/node": "~6.0.60",
    "codelyzer": "^4.0.1",
    "jasmine-core": "~2.8.0",
    "jasmine-spec-reporter": "~4.2.1",
    "karma": "~2.0.0",
    "karma-chrome-launcher": "~2.2.0",
    "karma-coverage-istanbul-reporter": "^1.2.1",
    "karma-jasmine": "~1.1.0",
    "karma-jasmine-html-reporter": "^0.2.2",
    "protractor": "~5.1.2",
    "ts-node": "~4.1.0",
    "tslint": "~5.9.1",
    "typescript": "3.9.7"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/form-library/examples/nest-follow-up-questions-within-choice-options/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/nest-follow-up-questions-within-choice-options/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/nest-follow-up-questions-within-choice-options/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/nest-follow-up-questions-within-choice-options/vanillajs.md)
